/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface VertexAiRagEngineConfigConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#id VertexAiRagEngineConfig#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#project VertexAiRagEngineConfig#project}
    */
    readonly project?: string;
    /**
    * The region of the RagEngineConfig. eg us-central1
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#region VertexAiRagEngineConfig#region}
    */
    readonly region?: string;
    /**
    * rag_managed_db_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#rag_managed_db_config VertexAiRagEngineConfig#rag_managed_db_config}
    */
    readonly ragManagedDbConfig: VertexAiRagEngineConfigRagManagedDbConfig;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#timeouts VertexAiRagEngineConfig#timeouts}
    */
    readonly timeouts?: VertexAiRagEngineConfigTimeouts;
}
export interface VertexAiRagEngineConfigRagManagedDbConfigBasic {
}
export declare function vertexAiRagEngineConfigRagManagedDbConfigBasicToTerraform(struct?: VertexAiRagEngineConfigRagManagedDbConfigBasicOutputReference | VertexAiRagEngineConfigRagManagedDbConfigBasic): any;
export declare function vertexAiRagEngineConfigRagManagedDbConfigBasicToHclTerraform(struct?: VertexAiRagEngineConfigRagManagedDbConfigBasicOutputReference | VertexAiRagEngineConfigRagManagedDbConfigBasic): any;
export declare class VertexAiRagEngineConfigRagManagedDbConfigBasicOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): VertexAiRagEngineConfigRagManagedDbConfigBasic | undefined;
    set internalValue(value: VertexAiRagEngineConfigRagManagedDbConfigBasic | undefined);
}
export interface VertexAiRagEngineConfigRagManagedDbConfigScaled {
}
export declare function vertexAiRagEngineConfigRagManagedDbConfigScaledToTerraform(struct?: VertexAiRagEngineConfigRagManagedDbConfigScaledOutputReference | VertexAiRagEngineConfigRagManagedDbConfigScaled): any;
export declare function vertexAiRagEngineConfigRagManagedDbConfigScaledToHclTerraform(struct?: VertexAiRagEngineConfigRagManagedDbConfigScaledOutputReference | VertexAiRagEngineConfigRagManagedDbConfigScaled): any;
export declare class VertexAiRagEngineConfigRagManagedDbConfigScaledOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): VertexAiRagEngineConfigRagManagedDbConfigScaled | undefined;
    set internalValue(value: VertexAiRagEngineConfigRagManagedDbConfigScaled | undefined);
}
export interface VertexAiRagEngineConfigRagManagedDbConfigUnprovisioned {
}
export declare function vertexAiRagEngineConfigRagManagedDbConfigUnprovisionedToTerraform(struct?: VertexAiRagEngineConfigRagManagedDbConfigUnprovisionedOutputReference | VertexAiRagEngineConfigRagManagedDbConfigUnprovisioned): any;
export declare function vertexAiRagEngineConfigRagManagedDbConfigUnprovisionedToHclTerraform(struct?: VertexAiRagEngineConfigRagManagedDbConfigUnprovisionedOutputReference | VertexAiRagEngineConfigRagManagedDbConfigUnprovisioned): any;
export declare class VertexAiRagEngineConfigRagManagedDbConfigUnprovisionedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): VertexAiRagEngineConfigRagManagedDbConfigUnprovisioned | undefined;
    set internalValue(value: VertexAiRagEngineConfigRagManagedDbConfigUnprovisioned | undefined);
}
export interface VertexAiRagEngineConfigRagManagedDbConfig {
    /**
    * basic block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#basic VertexAiRagEngineConfig#basic}
    */
    readonly basic?: VertexAiRagEngineConfigRagManagedDbConfigBasic;
    /**
    * scaled block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#scaled VertexAiRagEngineConfig#scaled}
    */
    readonly scaled?: VertexAiRagEngineConfigRagManagedDbConfigScaled;
    /**
    * unprovisioned block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#unprovisioned VertexAiRagEngineConfig#unprovisioned}
    */
    readonly unprovisioned?: VertexAiRagEngineConfigRagManagedDbConfigUnprovisioned;
}
export declare function vertexAiRagEngineConfigRagManagedDbConfigToTerraform(struct?: VertexAiRagEngineConfigRagManagedDbConfigOutputReference | VertexAiRagEngineConfigRagManagedDbConfig): any;
export declare function vertexAiRagEngineConfigRagManagedDbConfigToHclTerraform(struct?: VertexAiRagEngineConfigRagManagedDbConfigOutputReference | VertexAiRagEngineConfigRagManagedDbConfig): any;
export declare class VertexAiRagEngineConfigRagManagedDbConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): VertexAiRagEngineConfigRagManagedDbConfig | undefined;
    set internalValue(value: VertexAiRagEngineConfigRagManagedDbConfig | undefined);
    private _basic;
    get basic(): VertexAiRagEngineConfigRagManagedDbConfigBasicOutputReference;
    putBasic(value: VertexAiRagEngineConfigRagManagedDbConfigBasic): void;
    resetBasic(): void;
    get basicInput(): VertexAiRagEngineConfigRagManagedDbConfigBasic | undefined;
    private _scaled;
    get scaled(): VertexAiRagEngineConfigRagManagedDbConfigScaledOutputReference;
    putScaled(value: VertexAiRagEngineConfigRagManagedDbConfigScaled): void;
    resetScaled(): void;
    get scaledInput(): VertexAiRagEngineConfigRagManagedDbConfigScaled | undefined;
    private _unprovisioned;
    get unprovisioned(): VertexAiRagEngineConfigRagManagedDbConfigUnprovisionedOutputReference;
    putUnprovisioned(value: VertexAiRagEngineConfigRagManagedDbConfigUnprovisioned): void;
    resetUnprovisioned(): void;
    get unprovisionedInput(): VertexAiRagEngineConfigRagManagedDbConfigUnprovisioned | undefined;
}
export interface VertexAiRagEngineConfigTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#create VertexAiRagEngineConfig#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#delete VertexAiRagEngineConfig#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#update VertexAiRagEngineConfig#update}
    */
    readonly update?: string;
}
export declare function vertexAiRagEngineConfigTimeoutsToTerraform(struct?: VertexAiRagEngineConfigTimeouts | cdktf.IResolvable): any;
export declare function vertexAiRagEngineConfigTimeoutsToHclTerraform(struct?: VertexAiRagEngineConfigTimeouts | cdktf.IResolvable): any;
export declare class VertexAiRagEngineConfigTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): VertexAiRagEngineConfigTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: VertexAiRagEngineConfigTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config google_vertex_ai_rag_engine_config}
*/
export declare class VertexAiRagEngineConfig extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_vertex_ai_rag_engine_config";
    /**
    * Generates CDKTF code for importing a VertexAiRagEngineConfig resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the VertexAiRagEngineConfig to import
    * @param importFromId The id of the existing VertexAiRagEngineConfig that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the VertexAiRagEngineConfig to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google/6.50.0/docs/resources/vertex_ai_rag_engine_config google_vertex_ai_rag_engine_config} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options VertexAiRagEngineConfigConfig
    */
    constructor(scope: Construct, id: string, config: VertexAiRagEngineConfigConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get name(): string;
    private _project?;
    get project(): string;
    set project(value: string);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _ragManagedDbConfig;
    get ragManagedDbConfig(): VertexAiRagEngineConfigRagManagedDbConfigOutputReference;
    putRagManagedDbConfig(value: VertexAiRagEngineConfigRagManagedDbConfig): void;
    get ragManagedDbConfigInput(): VertexAiRagEngineConfigRagManagedDbConfig | undefined;
    private _timeouts;
    get timeouts(): VertexAiRagEngineConfigTimeoutsOutputReference;
    putTimeouts(value: VertexAiRagEngineConfigTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | VertexAiRagEngineConfigTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
